#!/bin/sh

## Testing the dataflash: AT45DB642 
## 
## Page = 1056 bytes (1K + 32) => 0x420 (0x400+0x020) 
## Block = 8448 bytes (8K + 256) =>  8 x Pages 
## Sector = 32 Blocks (Except Sector 0 = 1 x block (0); Sector [1-31] = 31 x blocks). 
## 
## Total: 32 sectors = 1024 blocks = 8192 pages = 8650752 bytes
##	: 0x84'0000 bytes
 	  	
displayErr() {

if [ "$md5w" != "$md5r" ]; then
	echo "ERROR @ $testdev W:$md5w, R:$md5r"
	cmp -l /testing/at91bootstrap.bin /tmp/nand-at91 > /tmp/cmprw
	head -n 1 /tmp/cmprw
	tail -n 1 /tmp/cmprw
	hexdump -n 500 -v /tmp/nand-at91 
else 
	echo "OK @ $testnand R/W" 
fi  
}

flashAllSkip()
{
	echo "execute $1?"
	read -t 5 -p "Press any key to skip it (5s): " ret; 
}


printf "======: $0\n"


npages=8192
ipage=0
dfdev=/dev/mtd2
f2w=/tmp/w1k.bin
f2r=/tmp/r1k.bin
nOK=0
nKO=0
ddopt="bs=1k count=1"

flashAllSkip "flash_eraseall ${dfdev}";
if [ -z ${ret} ]; then
	flash_eraseall ${dfdev}
fi

printf "Testing DF memory\n"
while [ $ipage -lt $npages ]; do
	
	if [ $(expr $ipage % 8)  -eq 0 ]; then
    		printf "B%04d:" $(expr $ipage / 8)
	fi

	if [ $(expr $ipage % 256)  -eq 0 ]; then
    		printf "\n\nSector %02d:" $(expr $ipage / 256)
	fi

	startaddr=$(expr $ipage \* 1056)
	

	dd $ddopt if=/dev/urandom of=${f2w} 		  2> /dev/null
	dd $ddopt if=${f2w} of=${dfdev} seek=${startaddr} 2> /dev/null
	dd $ddopt if=${dfdev} of=${f2r} skip=${startaddr} 2> /dev/null

	md5w=`md5sum ${f2w} | cut -f1 -d" "`
	md5r=`md5sum ${f2r} | cut -f1 -d" "`

	if [ "$md5w" != "$md5r" ]; then
		nKO=$(expr ${nKO} + 1)		
		echo "ERROR @ $startaddr"
	else
		nOK=$(expr ${nOK} + 1) 
		printf "."
	fi

	ipage=$(expr $ipage + 1)         


done

echo ""
echo "Result DF testing: OK=${nOK}/${npages}"

