#!/bin/sh


# Testing the cpu-fpga bus (EBI0)
# in memory range 0x10000000-0x10004000
# using the devmem application

#First loading the correct firmwares:
${APTS_LOCAL_DIR}/load-virtex ${APTS_LOCAL_DIR}/test_scb.bin
${APTS_LOCAL_DIR}/lm32-loader ${APTS_LOCAL_DIR}/rt_cpu.bin 

nTot=512
addr=0x10000000
end=0x10004000
step=32
nOK=0


let addr10=$addr
let end10=$end

printf "======: $0\n"
printf "Testing CPU-FPGA bus (EBI0 @  $addr > $end): "
while [ $addr10 -lt $end10 ]; do


	rand=`dd if=/dev/urandom count=1 2> /dev/null | cksum | cut -f1 -d" "`
	val=`printf "0x%08X" $rand`

	devmem $addr 32 $val
	ret=`devmem $addr`

	if [ $val != $ret ]; then
		echo "ERROR @ $addr W:$val, R:$ret"
	else
		nOK=`expr ${nOK} + 1` 
	fi         


	if [ `expr $addr10 % 1024`  -eq 0 ]; then
    		printf "."
	fi


	addr10=`expr $addr10 + $step`
	addr=`printf "0x%X" $addr10`

done

echo ""
echo "Result CPU-FPGA bus: OK=${nOK}/${nTot}W"
