#!/bin/sh

dd bs=28 count=1 if=/dev/mtd2 of=/tmp/b0
dd bs=28 count=1 if=${APTS_ROOT_DIR}/at91bootstrap.bin of=/tmp/b1
diff /tmp/b0 /tmp/b1 > /dev/null
if [ $? != "0" ]; then 
        read -p "# Did you flash firmware before $sh? [y/N]: " valid;
	if [ "${valid}" == "y" ]; then
		echo "ERROR: /dev/mtd2 does not contains valid data"
		exit 1
	else
		echo "Skipping check previous flashing"
	fi
fi 


printf "======: $0\n"
printf "Checking flash\n"

fname="at91bootstrap.bin"
ddopt=""

size=`ls -l ${APTS_ROOT_DIR}/${fname} | awk '{print $5}'`
dd bs=1 count=${size} ${ddopt} if=/dev/mtd2 of=/tmp/${fname}
diff ${APTS_ROOT_DIR}/${fname} /tmp/${fname} > /dev/null
if [ $? == "0" ]; then 
	echo "VALID: ${fname} checked"
else
        echo "ERROR: ${fname} is not correctly load on dataflash"
fi 


fname="barebox.bin"
ddopt="skip=33792" #skip is in block size


size=`ls -l ${APTS_ROOT_DIR}/${fname} | awk '{print $5}'`
dd bs=1 count=${size} ${ddopt} if=/dev/mtd2 of=/tmp/${fname}
diff ${APTS_ROOT_DIR}/${fname} /tmp/${fname} > /dev/null
if [ $? == "0" ]; then 
	echo "VALID: ${fname} checked"
else
        echo "ERROR: ${fname} is not correctly load on dataflash"
fi 
