#!/bin/sh

# Testing the data flash and NAND memory
# Dataflash is at /dev/mtd2
# NAND is at /dev/mtd0


## Function 
# Write random image, read it and compare md5sum
#
# Inputs:
# 	testdev: the device to test
# 	size: size of the device to test
ddmd5diff() {
	ls $testdev
	printf " creating random data...\n" 
	dd bs=1k $ncount if=/dev/urandom > /tmp/w
	printf " writing random data...\n" 	
	cat /tmp/w > $testdev
	printf " reading random data...\n" 
	dd  bs=1k $ncount if=$testdev > /tmp/r
	md5w=`md5sum /tmp/w | cut -f1 -d" "`
	md5r=`md5sum /tmp/r | cut -f1 -d" "`
	if [ "$md5w" != "$md5r" ]; then
		echo "ERROR @ $testdev W:$md5w, R:$md5r"
		cmp -l /tmp/r /tmp/w > /tmp/cmprw
		#nErrs=`cat /tmp/cmprw | wc -l`
		echo "nErrs=${nErrs}"
		head -n 1 /tmp/cmprw
		tail -n 1 /tmp/cmprw
	else 
		echo "OK @ $testdev R/W" 
	fi
}

## obtain the brute size
brutesize()
{
	size=$(expr $(cat $testdev | wc -c) / 1024)
	echo $size
}

printf "======: $0\n"
printf "Testing Dataflash memory (This test may take some time)\n Be sure to flash the firmware after this step"
## Testing the DF memory (8.25 MB = 0x840000)
ncount="count=8192"
testdev=/dev/mtd2 
ddmd5diff

printf "Testing Dataflash memory\n"
## Testing the NAND memory
testdev=/dev/mtd0 
#ddmd5diffprintf "creating random data.../n" 
