#!/bin/sh

## A page is about 4224 (0x1080) byte
## everything is FFFF except from 0 from 0x0800>0x840 & 0x1040>0x1080)

printf "======: $0\n"
printf "Testing NAND memory"

dd bs=1k count=1 if=/dev/urandom > /tmp/w1k.bin

nandwrite  -p /dev/mtd0  at91bootstrap.bin                                                                                            
nanddump --length=3564 --file=/tmp/nand-at91 /dev/mtd0

md5w=`md5sum /testing/at91bootstrap.bin | cut -f1 -d" "`
md5r=`md5sum /tmp/nand-at91 | cut -f1 -d" "`
if [ "$md5w" != "$md5r" ]; then
	echo "ERROR @ $testdev W:$md5w, R:$md5r"
	cmp -l /testing/at91bootstrap.bin /tmp/nand-at91 > /tmp/cmprw
	head -n 1 /tmp/cmprw
	tail -n 1 /tmp/cmprw
	hexdump -n 500 -v /tmp/nand-at91 
else 
	echo "OK @ $testnand R/W" 
fi                                                                               

