#!/bin/sh

## Parameters
export APTS_LOCAL_DIR="/alpha-pts"
export APTS_SERVER_DIR="alpha-pts"
export APTS_SERVER_IP="192.168.7.1"


load_ask2run() 
{
	sh=$1
	echo ""
	read -t 5 -p "# Execute $sh? (timeout in 5s) [Y/n]: " valid;
	if [ "${valid}" != "n" ]; then

	# Load script 
	tftp -g -r ${APTS_SERVER_DIR}/$sh  ${APTS_SERVER_IP}
	chmod +x ${APTS_LOCAL_DIR}/$sh

	# Run it into the log
	${APTS_LOCAL_DIR}/$sh 2>&1 | tee -a $logfile
	
	else
		echo -e "Skip the script $sh"
	fi
}

#Go to test directory
cd ${APTS_LOCAL_DIR}

# Obtain mac address
MAC=$(ifconfig | grep 'eth0'    | tr -s ' '    | cut -d ' ' -f5 | sed s/://g)
logfile="${APTS_LOCAL_DIR}/output-$MAC.log"

# Put timestamp in the log
echo "" >> $logfile
echo "-----------------------------------------------" >> $logfile
echo "$(date)" >> $logfile
echo "" >> $logfile

# Run the scritps
load_ask2run loadingfpga.sh
load_ask2run cpuebi0fpga.sh
load_ask2run checkflash.sh
load_ask2run devmemtesting.sh
load_ask2run flashingimgs.sh
load_ask2run nandflashing.sh









